#ifndef __ComponentA_hpp__
#define __ComponentA_hpp__

#include <rtt/TaskContext.hpp>
#include <rtt/Ports.hpp>
#include <rtt/Property.hpp>

#include "Bar.hpp"

namespace Test
{
  class ComponentA : public RTT::TaskContext
  {
    // ports
    RTT::WriteDataPort<Bar>    m_bar_port;
	  
    // properties
    RTT::Property<std::string> m_a_string;
    RTT::Property<unsigned>    m_an_unsigned;

    Bar m_bar;

  public:

    ComponentA(std::string name); 
	  
    /**
     * This function is for the configuration code.
     * Return false to abort configuration.
     */
    bool configureHook();

    /**
     * This function is for the application's start up code.
     * Return false to abort start up.
     */
    bool startHook();

    /**
     * This function is called by the Execution Engine.
     */
    void updateHook();

    /**
     * This function is called when the task is stopped.
     */
    void stopHook();

    /**
     * This function is called when the task is being deconfigured.
     */
    void cleanupHook();
  };
}

#endif /* define __ComponentA_hpp__ */
