#include <rtt/Logger.hpp>

#include "ComponentB.hpp"

namespace Test
{ 

ComponentB::ComponentB(std::string name) : 
  RTT::TaskContext(name),
  // ports
  m_bar_port("bar")
{
  RTT::Logger::In in(__PRETTY_FUNCTION__);
  RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
  // ports
  this->ports()->addPort( &m_bar_port );
  RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
}
  
/**
 * This function is for the configuration code.
 * Return false to abort configuration.
 */
bool ComponentB::configureHook() 
{
  RTT::Logger::In in(__PRETTY_FUNCTION__);
  RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
  RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
  return true;
}

/**
 * This function is for the application's start up code.
 * Return false to abort start up.
 */
bool ComponentB::startHook() 
{
  RTT::Logger::In in(__PRETTY_FUNCTION__);
  RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
  m_bar.m_flag = false;
  RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
  return true;
}

/**
 * This function is called by the Execution Engine.
 */
void ComponentB::updateHook() 
{
  RTT::Logger::In in(__PRETTY_FUNCTION__);
  RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
  m_bar_port.Get(m_bar);
  RTT::Logger::log( RTT::Logger::Debug ) << m_bar.m_flag << RTT::Logger::endl;
  RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
}

/**
 * This function is called when the task is stopped.
 */
void ComponentB::stopHook() 
{
  RTT::Logger::Logger::In in(__PRETTY_FUNCTION__);
  RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
  RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
}

/**
 * This function is called when the task is being deconfigured.
 */
void ComponentB::cleanupHook() 
{
  RTT::Logger::Logger::In in(__PRETTY_FUNCTION__);
  RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
  RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
}

}

#include <ocl/ComponentLoader.hpp>
ORO_LIST_COMPONENT_TYPE(Test::ComponentB)

