#ifndef __ComponentB_hpp__
#define __ComponentB_hpp__

#include <rtt/TaskContext.hpp>
#include <rtt/Ports.hpp>
#include <rtt/Property.hpp>

#include "Bar.hpp"

namespace Test
{
  class ComponentB : public RTT::TaskContext
  {
    // ports
    RTT::ReadDataPort<Bar>    m_bar_port;
	  
    Bar m_bar;

  public:

    ComponentB(std::string name); 
	  
    /**
     * This function is for the configuration code.
     * Return false to abort configuration.
     */
    bool configureHook();

    /**
     * This function is for the application's start up code.
     * Return false to abort start up.
     */
    bool startHook();

    /**
     * This function is called by the Execution Engine.
     */
    void updateHook();

    /**
     * This function is called when the task is stopped.
     */
    void stopHook();

    /**
     * This function is called when the task is being deconfigured.
     */
    void cleanupHook();
  };
}

#endif /* define __ComponentB_hpp__ */
